#include "mcu_init.h"
#include "config.h"
#include "device.h"
#include "spi2.h"
#include "socket.h"
#include "w5500.h"
#include "at24c16.h"
#include "util.h"

#include <stdio.h>

extern uint8 txsize[];
extern uint8 rxsize[];

uint8 buffer[2048];/*һ2KBĻ*/

void main()
{
  uint16 port=30000;/*һ˿ڲʼ*/
  uint16 len=0;
   
  uint8 mac[6]={0x00,0x08,0xdc,0x11,0x11,0x11};/*Mac*/
  uint8 lip[4]={192,168,10,111};/*lp*/
  uint8 sub[4]={255,255,255,0};/*subnet*/
  uint8 gw[4]={192,168,10,1};/*gateway*/
  uint8 ip[4];
  
  RCC_Configuration(); /* õƬϵͳʱ*/
  GPIO_Configuration();/* GPIO*/
  NVIC_Configuration();/* Ƕж*/
  
  Systick_Init(72);/* ʼSystickʱ*/
  USART1_Init(); /*ʼͨ:115200@8-n-1*/
  at24c16_init();/*ʼeeprom*/
  printf("W5500 EVB initialization over.\r\n");
  
  Reset_W5500();/*ӲW5500*/
  WIZ_SPI_Init();/*ʼSPIӿ*/
  printf("W5500 initialized!\r\n");  
 
  setSHAR(mac);/*Macַ*/
  setSUBR(sub);/**/
  setGAR(gw);/*Ĭ*/
  setSIPR(lip);/*Ipַ*/
  
    //Init. TX & RX Memory size of w5500
  sysinit(txsize, rxsize); /*ʼ8socket*/
  
  setRTR(2000);/*ʱֵ*/
  setRCR(3);/*·ʹ*/
  

  getSIPR (ip);
  printf("IP : %d.%d.%d.%d\r\n", ip[0],ip[1],ip[2],ip[3]);
  getSUBR(ip);
  printf("SN : %d.%d.%d.%d\r\n", ip[0],ip[1],ip[2],ip[3]);
  getGAR(ip);
  printf("GW : %d.%d.%d.%d\r\n", ip[0],ip[1],ip[2],ip[3]);
  printf("Network is ready.\r\n");
  
  while(1)
  {
    switch(getSn_SR(0))/*ȡsocket0״̬*/
      {
         case SOCK_INIT:/*socketʼ*/
           listen(0);/*TCPģʽ*/
   
           break;
         case SOCK_ESTABLISHED:/*socketӽ*/
           if(getSn_IR(0) & Sn_IR_CON)
           {
              setSn_IR(0, Sn_IR_CON);/*Sn_IRĵ0λ1*/
            }
           len=getSn_RX_RSR(0);/*lenΪѽݵĴС*/
           if(len>0)
           {
              recv(0,buffer,len);/*W5200Sever*/
              send(0,buffer,len);/*W5200Server*/
            }
           break;
         case SOCK_CLOSE_WAIT:/*socketȴر״̬*/
           break;
         case SOCK_CLOSED:/*socketر*/
           socket(0,Sn_MR_TCP,port,Sn_MR_ND);/*socket0һ˿*/
           break;
     }
  }
}