#include <stdio.h>
#include <string.h>
#include "mcu_init.h"
#include "config.h"
#include "device.h"
#include "spi2.h"
#include "socket.h"
#include "w5500.h"
#include "at24c16.h"
#include "util.h"
#include "dns.h"

#include <stdio.h>

extern uint8 txsize[];
extern uint8 rxsize[];

uint8 buffer[2048];/*һ2KBĻ*/
  
void main()
{
  uint8 dns_retry_cnt=0;
  uint8 dns_ok=0;
  
  RCC_Configuration(); /* õƬϵͳʱ*/
  GPIO_Configuration();/* GPIO*/
  NVIC_Configuration();/* Ƕж*/
  
  Systick_Init(72);/* ʼSystickʱ*/
  USART1_Init(); /*ʼͨ:115200@8-n-1*/
  at24c16_init();/*ʼeeprom*/
  printf("W5500 EVB initialization over.\r\n");
  
  Reset_W5500();/*ӲW5500*/
  WIZ_SPI_Init();/*ʼSPIӿ*/
  printf("W5500 initialized!\r\n");  
  
  set_default();/*ʼò*/
  set_network();/**/

  printf("dns init over\r\n");
  
  while(1)
  { 
    if( (dns_ok==1) ||  (dns_retry_cnt > DNS_RETRY))
    {
      return;
    }
    else if(memcmp(ConfigMsg.dns,"\x00\x00\x00\x00",4))
    {
      switch(dns_query(SOCK_DNS,ConfigMsg.domain)) /*DNS*/
      {
        case DNS_RET_SUCCESS:
          dns_ok=1;
          memcpy(ConfigMsg.rip,DNS_GET_IP,4);
          dns_retry_cnt=0;
          printf("Get [%s]'s IP address [%d.%d.%d.%d] from %d.%d.%d.%d\r\n",ConfigMsg.domain,ConfigMsg.rip[0],ConfigMsg.rip[1],ConfigMsg.rip[2],ConfigMsg.rip[3],ConfigMsg.dns[0],ConfigMsg.dns[1],ConfigMsg.dns[2],ConfigMsg.dns[3]);
          break;
        case DNS_RET_FAIL:
          dns_ok=0;
          dns_retry_cnt++;
          printf("Fail! Please check your network configuration or DNS server.\r\n");
          break;
        default:
          break;
      }
    
  }
  else
     printf("Invalid DNS server [%d.%d.%d.%d]\r\n",ConfigMsg.dns[0],ConfigMsg.dns[1],ConfigMsg.dns[2],ConfigMsg.dns[3]);

  }
}