#include <stdio.h>
#include <string.h>
#include "mcu_init.h"
#include "config.h"
#include "device.h"
#include "spi2.h"
#include "socket.h"
#include "w5500.h"
#include "at24c16.h"
#include "util.h"
#include "dns.h"
#include "smtp.h"

#include <stdio.h>

extern uint8 txsize[];
extern uint8 rxsize[];

extern  uint8 Mail_Send_OK;

uint8 buffer[2048];/*һ2KBĻ*/
  
void main()
{
  
  RCC_Configuration(); /* õƬϵͳʱ*/
  GPIO_Configuration();/* GPIO*/
  NVIC_Configuration();/* Ƕж*/
  
  Systick_Init(72);/* ʼSystickʱ*/
  USART1_Init(); /*ʼͨ:115200@8-n-1*/
  at24c16_init();/*ʼeeprom*/
  printf("W5500 EVB initialization over.\r\n");
  
  Reset_W5500();/*ӲW5500*/
  WIZ_SPI_Init();/*ʼSPIӿ*/
  printf("W5500 initialized!\r\n");  
  
  set_default();/*ʼò*/
  set_network();/**/

  mailmessage();/*ʼʼϢ*/

  printf("Network is ready!\r\n");
  
  while(1)
  {
    do_dns();
    do_smtp();
    if(Mail_Send_OK)
      while(1);  
  }
}