#include "mcu_init.h"
#include "config.h"
#include "device.h"
#include "spi2.h"
#include "socket.h"
#include "w5500.h"
#include "at24c16.h"
#include "util.h"
#include "ntp.h"
#include <stdio.h>

extern uint8 txsize[];
extern uint8 rxsize[];

uint8 buffer[2048];/*һ2KBĻ*/
  
void main()
{
  uint8 mac[6]={0x00,0x08,0xdc,0x11,0x11,0x11};/*Mac*/
  uint8 lip[4]={192,168,1,115};/*lp*/
  uint8 sub[4]={255,255,255,0};/*subnet*/
  uint8 gw[4]={192,168,1,1};/*gateway*/
  uint8 ip[4];
  
  RCC_Configuration(); /* õƬϵͳʱ*/
  GPIO_Configuration();/* GPIO*/
  NVIC_Configuration();/* Ƕж*/
  
  Systick_Init(72);/* ʼSystickʱ*/
  USART1_Init(); /*ʼͨ:115200@8-n-1*/
  at24c16_init();/*ʼeeprom*/
  printf("W5500 EVB initialization over.\r\n");
  
  Reset_W5500();/*ӲW5500*/
  WIZ_SPI_Init();/*ʼSPIӿ*/
  printf("W5500 initialized!\r\n");  
  
  setSHAR(mac);/*Macַ*/
  setSUBR(sub);/**/
  setGAR(gw);/*Ĭ*/
  setSIPR(lip);/*Ipַ*/
  
    //Init. TX & RX Memory size of w5500
  sysinit(txsize, rxsize); /*ʼ8socket*/
  
  setRTR(2000);/*ʱֵ*/
  setRCR(3);/*·ʹ*/
  

  getSIPR (ip);
  printf("IP : %d.%d.%d.%d\r\n", ip[0],ip[1],ip[2],ip[3]);
  getSUBR(ip);
  printf("SN : %d.%d.%d.%d\r\n", ip[0],ip[1],ip[2],ip[3]);
  getGAR(ip);
  printf("GW : %d.%d.%d.%d\r\n", ip[0],ip[1],ip[2],ip[3]);
  printf("Network is ready.\r\n");
  
  Timer_Configuration();
  ntpclient_init();
  
  while(1)
  {
    //ڵPing
    do_ntp_client();
  }
}