#include "stm32f10x.h"
#include "stm32f10x_exti.h"
#include "stdio.h"
#include "mcu_init.h"
#include "config.h"
#include "util.h"
#include "W5500\w5500.h"
#include "W5500\socket.h"
#include "W5500\spi2.h"
#include "APPs\loopback.h"

#include "device.h"
#include "at24c16.h"
#include <stdio.h>
#include <string.h>

CONFIG_MSG Config_Msg;
CHCONFIG_TYPE_DEF Chconfig_Type_Def; 

uint8 ch_status[MAX_SOCK_NUM] = { 0, };	/** 0:close, 1:ready, 2:connected */

uint8 TX_BUF[TX_RX_MAX_BUF_SIZE]; // TX Buffer for applications
uint8 RX_BUF[TX_RX_MAX_BUF_SIZE]; // RX Buffer for applications
   

/* Private function prototypes -----------------------------------------------*/
void RCC_Configuration(void);
void NVIC_Configuration(void);
void GPIO_Configuration(void);
void Timer_Configuration(void);
extern void EXTI_IMR_EMR_enable(void);

void main()
{
	
  RCC_Configuration(); /* õƬϵͳʱ*/
  GPIO_Configuration();/* GPIO*/
  NVIC_Configuration();/* Ƕж*/
//  Timer_Configuration();
  Systick_Init(72);/* ʼSystickʱ*/
  USART1_Init(); /*ʼͨ:115200@8-n-1*/
  at24c16_init();/*ʼeeprom*/
  printf("W5500 EVB initialization over.\r\n");
  
  Reset_W5500();/*ӲW5500*/
  WIZ_SPI_Init();/*ʼSPIӿ*/
  printf("W5500 initialized!\r\n");  
  set_default();
  set_network(); 
  //GPIO_ResetBits(GPIOA, LED0);
  GPIO_ResetBits(GPIOA, LED3);
// GPIO_SetBits(GPIOA, LED2); // led 
  while(1)
  {
	for (int m=0; m<3; m++)
	{
		GPIO_SetBits(GPIOA, LED2);
		Delay_ms(500);
		GPIO_ResetBits(GPIOA, LED2);
		Delay_ms(500);
	}
	UserSnmpDemo();
   }
}
