#include <stdio.h>

#include "config.h"
#include "w5500.h"
#include "socket.h"

uint8 n_connecting_printed=0;
uint8 n_listening_printed=0;
uint8 n_connect_cmd_flag=0;
static uint16 anyport=2000;

void do_notify(void)
{
  uint8 state;
  state=getSn_SR(SOCK_NOTIFY);
  switch(state)
  {
  case SOCK_UDP:
    //if(_kbhit() || u2e_size)               uart2ether();
    //if(getSn_RX_RSR(SOCK_NOTIFY) || e2u_size) ether2uart();
    
    break;
  case SOCK_SYNSENT:
    //printf("s");
    break;
  case SOCK_INIT:
    if(ConfigMsg.notify_mode == TCP_CLIENT_MODE)
    {
      
      if(n_connect_cmd_flag==0)
      {
        connect(SOCK_NOTIFY,ConfigMsg.notify_rip, ConfigMsg.notify_rport);
        
        n_connect_cmd_flag = 1;
      }
      else
        return;
      if((ConfigMsg.debug)) 
      {
        if(!n_connecting_printed)
        {
          n_connecting_printed=1;
          if(ConfigMsg.debug) printf("Connect %d.%d.%d.%d:%d\r\n",ConfigMsg.notify_rip[0],ConfigMsg.notify_rip[1],ConfigMsg.notify_rip[2],ConfigMsg.notify_rip[3],ConfigMsg.notify_rport); 
        }
      }
    }
    else 
    {
      listen(SOCK_NOTIFY);
      if((ConfigMsg.debug)) 
      {
        if(!n_listening_printed)
        {
          n_listening_printed=1;
          if(ConfigMsg.debug) printf("Listen on %d.%d.%d.%d:%d\r\n",ConfigMsg.lip[0],ConfigMsg.lip[1],ConfigMsg.lip[2],ConfigMsg.lip[3],ConfigMsg.notify_lport);
        }
      }
    }
    break;
  case SOCK_LISTEN:
    
    break;
  case SOCK_ESTABLISHED:
    if(getSn_IR(SOCK_NOTIFY) & Sn_IR_CON)
    {
      setSn_IR(SOCK_NOTIFY, Sn_IR_CON);
      if(ConfigMsg.debug) printf("Connected\r\n");
      
      n_connecting_printed=0;
      n_listening_printed=0;      
    }

    break;
  case SOCK_CLOSE_WAIT:      
    //while(getSn_RX_RSR(SOCK_DATA) || e2u_size) ether2uart();
    disconnect(SOCK_NOTIFY);
    break;
  case SOCK_CLOSED:
  case SOCK_FIN_WAIT:
    close(SOCK_NOTIFY);
    n_connect_cmd_flag = 0;

    if(ConfigMsg.notify_mode == UDP_MODE)
    {
      socket(SOCK_NOTIFY,Sn_MR_UDP,ConfigMsg.notify_lport,0);
    }
    else if(ConfigMsg.notify_mode == TCP_CLIENT_MODE)
    {
      while(socket(SOCK_NOTIFY,Sn_MR_TCP,anyport++,Sn_MR_ND)==0);
    
    }
    else if (ConfigMsg.notify_mode == TCP_SERVER_MODE )
    { 	
      socket(SOCK_NOTIFY,Sn_MR_TCP,ConfigMsg.notify_lport,Sn_MR_ND);	//Sn_MR_ND
      
    }
    break;
  default:
    //printf("0x%02x ", state);
    break;         
  }
  return;
}

