#ifndef __SERIAL_H
#define __SERIAL_H

#include "types.h"


#define  SIO_BUF_SIZE      2048
#define  SIO_XON_THRESHOLD  (uint16)(SIO_BUF_SIZE/10)
#define  SIO_XOFF_THRESHOLD  SIO_BUF_SIZE - SIO_XON_THRESHOLD

uint16 _kbhit(void);
uint16 uart_gets(uint8* buf, uint16 max);
uint8 uart_flowctrl_own(void);
uint8 uart_flowctrl_peer(void);
void PutByte(uint8 ch, uint8 data);
uint16 uart_gets(uint8* buf, uint16 max);

void uart_flush(void);

void json_serial_data(int8 *buf);//serial to web test

#endif  //  end __SERIAL_H
