#include "DHT11.h"

UINT8  OverTimeCnt = 0;
UINT8  tmpBit,tmp8BitValue;
UINT8  SensorValueBuf[4];
UINT8  CheckSum;

void Read8Bit(void);

#pragma optimize=none
static void Delay_nus(UINT16 s) 
{
  while (s--)
  {
    asm("NOP");
    asm("NOP");
    asm("NOP");
  }
}

void Read8Bit(void)
{
  UINT8 i;
  
  for(i=0;i<8;i++)
  {
    OverTimeCnt = 2;
    while((IN_DQ == 0)&&OverTimeCnt++);
    //while(IN_DQ == 0);
    Delay_nus(19);//12
    if(IN_DQ == 1)
      tmpBit = 1;
    else
      tmpBit = 0;
    OverTimeCnt = 2;
    while((IN_DQ == 1)&&OverTimeCnt++);
    //while(IN_DQ == 1);
    //ʱforѭ		  
    if(OverTimeCnt==1)
      break;
    
    tmp8BitValue<<=1;
    tmp8BitValue|=tmpBit;        //0
  
  }

}

void ReadValue(void)
{
  //UINT8 tmp;
  
  SET_OUT; 
  CL_DQ; 
  Delay_nus(20000);//18ms  
  SET_DQ;
  Delay_nus(20);// ʱ20us-40us
  SET_IN;
  if(IN_DQ == 0)
  {
    OverTimeCnt = 2;
    while((IN_DQ == 0)&&OverTimeCnt++);
    //жϴӻǷ񷢳 80us ĸߵƽ緢ݽ״̬
    //OverTimeCnt = 2;
    //while((IN_DQ == 1)&&OverTimeCnt++);
    while(IN_DQ == 1);
    //ݽ״̬	
    Read8Bit();
    SensorValueBuf[0] = tmp8BitValue;
    
    Read8Bit();
    SensorValueBuf[1] = tmp8BitValue;
    
    Read8Bit();
    SensorValueBuf[2] = tmp8BitValue;
    
    Read8Bit();
    SensorValueBuf[3] = tmp8BitValue;
    
    Read8Bit();
    CheckSum = tmp8BitValue;
    
    if(CheckSum == SensorValueBuf[0]+SensorValueBuf[1]+SensorValueBuf[2]+SensorValueBuf[3])
    {
      CheckSum = 0xff;
    
    }
    
  }

}