#ifndef DHT11_H
#define DHT11_H

#include "ioCC2530.h"

/******************************************************************************
*******************              Commonly used types        *******************
******************************************************************************/
#define BOOL unsigned char

// Data
#define BYTE unsigned char       
#define WORD unsigned short      
#define DWORD unsigned long       

// Unsigned numbers
#define UINT8 unsigned char       
#define UINT16 unsigned short      
#define UINT32 unsigned long       

// Signed numbers
#define INT8 signed char         
#define INT16 signed short        
#define INT32 signed long   


#define IN_DQ  P1_1
#define CL_DQ  IN_DQ=0;asm("NOP");asm("NOP")
#define SET_DQ IN_DQ=1;asm("NOP");asm("NOP") 
#define SET_OUT P1DIR|=0x02;asm("NOP");asm("NOP")
#define SET_IN  P1DIR&=~0x02;asm("NOP");asm("NOP")


void ReadValue(void);

#endif