#ifndef _CONFIG_H_
#define _CONFIG_H_

#include "Types.h"
#include "ioCC2530.h"      // ļõͷļ

//=================================================
typedef struct _CONFIG_MSG
{
  uint8 op[4];//header: FIND;SETT;FACT...
  uint8 mac[6];
  uint8 sw_ver[2];
  uint8 lip[4];
  uint8 sub[4];
  uint8 gw[4];
  uint8 dns[4];	
  uint8 dhcp;
  uint8 debug;

  uint16 fw_len;
  uint8 state;
  
}CONFIG_MSG;

#define CONFIG_MSG_LEN        sizeof(CONFIG_MSG) - 4 // the 4 bytes OP will not save to EEPROM
//



#define MAX_BUF_SIZE		1460
#define KEEP_ALIVE_TIME	        30	// 30sec


#define ON	1
#define OFF	0

#define HIGH		1
#define LOW		0

#define __GNUC__

// SRAM address range is 0x2000 0000 ~ 0x2000 BFFF (48KB)
#define SOCK_BUF_ADDR 	0x20000000


//extern CONFIG_MSG  ConfigMsg, RecvMsg;


#define SOCK_HUMTEM             0       //Humidity and temperature
#define SOCK_TCP		1	// TCP
#define SOCK_DNS		2	// UDP
#define SOCK_DHCP		3	// UDP
#define SOCK_LOC                4       //tcp
#define SOCK_NTP                5       //time
#define SOCK_TELNET             6       //tcp, telnet
#define SOCK_HTTP               7


#endif