#include "middle.h"

void initUart(halUARTCBack_t pf)
{
  halUARTCfg_t uartConfig;
  
  uartConfig.configured = TRUE;
  uartConfig.baudRate = HAL_UART_BR_115200;
  uartConfig.flowControl = FALSE;
  uartConfig.flowControlThreshold = 48;
  uartConfig.rx.maxBufSize = RX_BUF_LEN;
  uartConfig.tx.maxBufSize = 128;
  
  uartConfig.idleTimeout = 6; 
  uartConfig.intEnable = TRUE; 
  uartConfig.callBackFunc = pf;
  
  HalUARTOpen (HAL_UART_PORT_0, &uartConfig);
}

void uartRxCB( uint8 port, uint8 event )
{
  uint8 pBuf[RX_BUF_LEN];
  uint16 len;
  
  if ( event != HAL_UART_TX_EMPTY ) 
  {
    len = HalUARTRead(HAL_UART_PORT_0, pBuf, RX_BUF_LEN) ;//HalUARTReadѽյݴ洢pBuf
  }
}