#include "mcu_init.h"
#include "config.h"
#include "device.h"
#include "spi2.h"
#include "socket.h"
#include "w5500.h"
#include "at24c16.h"
#include "util.h"

#include <stdio.h>

extern uint8 txsize[];
extern uint8 rxsize[];

uint8 buffer[2048];/*һ2KBĻ*/

void main()
{
  uint8 pc_ip[4]={192,168,1,104};/*÷IPַ*/
  uint16 pc_port=6001;/*һ˿ڲʼ*/
  uint16 len=0;
  uint8 rIP[4];
  uint16 rPort;
  uint8 mac[6]={0x00,0x08,0xdc,0x11,0x11,0x11};/*Mac*/
  uint8 lip[4]={192,168,1,111};/*lp*/
  uint8 sub[4]={255,255,255,0};/*subnet*/
  uint8 gw[4]={192,168,1,1};/*gateway*/
  uint8 ip[4];
  uint8 test[10] = "test";
  uint32 counter=0;
  RCC_Configuration(); /* õƬϵͳʱ*/
  GPIO_Configuration();/* GPIO*/
  NVIC_Configuration();/* Ƕж*/
  
  Systick_Init(72);/* ʼSystickʱ*/
  USART1_Init(); /*ʼͨ:115200@8-n-1*/
  at24c16_init();/*ʼeeprom*/
  printf("W5500 EVB initialization over.\r\n");
  
  Reset_W5500();/*ӲW5500*/
  WIZ_SPI_Init();/*ʼSPIӿ*/
  printf("W5500 initialized!\r\n");  
 
  setSHAR(mac);/*Macַ*/
  setSUBR(sub);/**/
  setGAR(gw);/*Ĭ*/
  setSIPR(lip);/*Ipַ*/
  
    //Init. TX & RX Memory size of w5500
  sysinit(txsize, rxsize); /*ʼ8socket*/
  
  setRTR(2000);/*ʱֵ*/
  setRCR(3);/*·ʹ*/
  

  getSIPR (ip);
  printf("IP : %d.%d.%d.%d\r\n", ip[0],ip[1],ip[2],ip[3]);
  getSUBR(ip);
  printf("SN : %d.%d.%d.%d\r\n", ip[0],ip[1],ip[2],ip[3]);
  getGAR(ip);
  printf("GW : %d.%d.%d.%d\r\n", ip[0],ip[1],ip[2],ip[3]);
  printf("Network is ready.\r\n");
  
  while(1)
  {
    switch(getSn_SR(0))/*ȡsocket 0״̬*/
      {
         case SOCK_UDP:/*socket ׽ֳʼ*/
           //setSn_IR(0, Sn_IR_RECV);
           counter++;
           //sprintf(test, "test:%03d\r\n", counter);
           //sendto(0, test,10, pc_ip, pc_port);
           //Delay_ms(100);
           if(getSn_IR(0) & Sn_IR_RECV)
          {
            setSn_IR(0, Sn_IR_RECV);/*Sn_IRĵ0λ1*/
          }
           if((len=getSn_RX_RSR(0))>0)
           { 
              //recvfrom(0, buffer, len, pc_ip,&pc_port);/*W5200ռ*/
              recvfrom(0, buffer, len, rIP,&rPort);
              printf("%d.%d.%d.%d:%d", rIP[0],rIP[1],rIP[2],rIP[3],rPort);
              sendto(0, buffer,len, pc_ip, pc_port);/*W5200ѽյݷ͸*/
            }
           break;
         case SOCK_CLOSED:/*socket ر*/
           socket(0,Sn_MR_UDP,30000,0);/*ʼsocket 0׽*/
           break;
       }
  }
}