#ifndef __DHT11_H
#define __DHT11_H

#include "util.h"
#include "stm32f10x.h"
#include "config.h"

//-----------------DHT11ţPA12---------------------
#define DHT11         (1<<1)
//#define DHT11_SET(x)  GPIOA->ODR=(GPIOA->ODR&~DHT11)|(x ? DHT11:0)

#define rDHT11        GPIO_ReadInputDataBit(GPIOA , PA2)
#define DHT11_IO_IN()  {GPIOA->CRL&=0XFFFFF0FF;GPIOA->CRH|=0x00000800;} 
#define DHT11_IO_OUT() {GPIOA->CRL&=0XFFFFF0FF;GPIOA->CRH|=0x00000300;} 
//----------------------------------------------------

uint8 DHT11_GetValue(uint8 *p);

#endif
