#include "mcu_init.h"
#include "config.h"
#include "device.h"
#include "spi2.h"
#include "socket.h"
#include "w5500.h"
#include "at24c16.h"
#include "util.h"
#include "dht11.h"

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

extern uint8 txsize[];
extern uint8 rxsize[];
extern uint8 send_flag;

uint8 Buffer[1024]={0};
uint8 temp_rh[2];//p[0]ʪ p[1]¶

char  postT[]={//ύ¶
"POST /v1.0/device/4469/sensor/6479/datapoints HTTP/1.1\r\n"
"Host: api.yeelink.net\r\n"
"Accept: */*\r\n"
"U-ApiKey: 47278c6ec76acb7780e553698c88c645\r\n"
"Content-Length: 12\r\n"
"Content-Type: application/x-www-form-urlencoded\r\n"
"Connection: close\r\n"
"\r\n"
"{\"value\":xx}\r\n"
};//xxֵ
char  postH[]={//ύʪ
"POST /v1.0/device/4469/sensor/6611/datapoints HTTP/1.1\r\n"
"Host: api.yeelink.net\r\n"
"Accept: */*\r\n"
"U-ApiKey: 47278c6ec76acb7780e553698c88c645\r\n"
"Content-Length: 12\r\n"
"Content-Type: application/x-www-form-urlencoded\r\n"
"Connection: close\r\n"
"\r\n"
"{\"value\":xx}\r\n"
};//xxֵ
char *post[]={postH,postT};

void main()
{  
  RCC_Configuration(); /* õƬϵͳʱ*/
  GPIO_Configuration();/* GPIO*/
  NVIC_Configuration();/* Ƕж*/
  
  Systick_Init(72);/* ʼSystickʱ*/
  USART1_Init(); /*ʼͨ:115200@8-n-1*/
  at24c16_init();/*ʼeeprom*/
  printf("W5500 EVB initialization over.\r\n");
  
  Reset_W5500();/*ӲW5500*/
  WIZ_SPI_Init();/*ʼSPIӿ*/
  printf("W5500 initialized!\r\n");  

  Timer_Configuration();
  
  set_default();
  set_network();
  DHT11_GetValue(temp_rh);
  
  while(1)
  {
    static uint8 i=0;
    uint8 ch=SOCK_HUMTEM;
    uint16 anyport=5000;
    uint8 server_ip[4]={42,96,164,52};//  api.yeelink.net  ipַ
    for(int i=0; i<10;i++)
     Delay_ms(1000);
    switch(getSn_SR(ch))
    {
      case SOCK_INIT:
        //if(send_flag==1)
        //{
          connect(ch, server_ip ,80);
          send_flag=0;
        //}
        break;
      case SOCK_ESTABLISHED:
       //case SOCK_CLOSE_WAIT:
        if(getSn_IR(ch) & Sn_IR_CON)
        {
          setSn_IR(ch, Sn_IR_CON);
        }
        if( DHT11_GetValue(temp_rh))
        {
          memcpy(Buffer,post[i],strlen(post[i]));
	  Buffer[235]=temp_rh[i]/10+0x30;
	  Buffer[236]=temp_rh[i]%10+0x30;
          send(ch,(const uint8 *)Buffer,sizeof(Buffer));
          i=!i;
          disconnect(ch);
        }
        printf("RH:%d, Temp:%d\r\n", temp_rh[0], temp_rh[1]);
         break;
      case SOCK_CLOSE_WAIT:   
        if( DHT11_GetValue(temp_rh))
        {
          memcpy(Buffer,post[i],strlen(post[i]));
	  Buffer[235]=temp_rh[i]/10+0x30;
	  Buffer[236]=temp_rh[i]%10+0x30;
          send(ch,(const uint8 *)Buffer,sizeof(Buffer));
          i=!i;
          disconnect(ch);
        }
        printf("Send to Yeelink:OK\r\n");
        break;
      case SOCK_CLOSED:                   
        socket(ch, Sn_MR_TCP,anyport , 0x00);   
        break;
      default:
        break;
   }   
 }
}


  
