
#include "config.h"
#include "w5500.h"
#include "socket.h"
#include "util.h"
#include "loopback.h"
#include <stdio.h>

u8 ch_status[MAX_SOCK_NUM];

u8 data_buf[TX_RX_MAX_BUF_SIZE];

void loopback_tcps(u8 ch, u16 port)
{
    u32 len;  
    switch(getSn_SR(ch))/*ȡsocket0״̬*/
    {
       case SOCK_INIT:/*socketʼ*/
         listen(ch);/*TCPģʽ*/
 
         break;
       case SOCK_ESTABLISHED:/*socketӽ*/
         if(getSn_IR(ch) & Sn_IR_CON)
         {
            setSn_IR(ch, Sn_IR_CON);/*Sn_IRĵ0λ1*/
          }
         len=getSn_RX_RSR(ch);/*lenΪѽݵĴС*/
         if(len>0)
         {
            recv(ch,data_buf,len);/*W5200Sever*/
            send(ch,data_buf,len);/*W5200Server*/
          }
         break;
       case SOCK_CLOSE_WAIT:/*socketȴر״̬*/
         break;
       case SOCK_CLOSED:/*socketر*/
         socket(ch,Sn_MR_TCP,port,Sn_MR_ND);/*socket0һ˿*/
         break;
   }
}

void loopback_udp(u8 ch, u16 port)
{
    int len;
    u8 destip[4];
    u16 destport;
    switch(getSn_SR(ch))/*ȡsocket 0״̬*/
    {
     case SOCK_UDP:/*socket ׽ֳʼ*/
       if(getSn_IR(ch) & Sn_IR_RECV)
      {
        setSn_IR(ch, Sn_IR_RECV);/*Sn_IRĵ0λ1*/
      }
       if((len=getSn_RX_RSR(ch))>0)
       { 
          recvfrom(ch, data_buf, len, (u8*)&destip, &destport);
          printf("\r\n%d.%d.%d.%d:%d", destip[0],destip[1],destip[2],destip[3],destport);
          sendto(ch, data_buf,len, (u8*)&destip ,destport);/*W5200ѽյݷ͸*/
        }
       break;
     case SOCK_CLOSED:/*socket ر*/
       socket(ch,Sn_MR_UDP,port,0);/*ʼsocket 0׽*/
       break;
    }
}
