#include "config.h"
#include "at24c32.h"

#include <stdio.h>

extern USER_RULE rules[TOTAL_RULE_NUM];

uint8 add_one_rule(USER_RULE r)
{
  uint16 offset=RULE_START_ADDR + ConfigMsg.num_rules * RULE_LEN;
  for(uint16 i=0;i<RULE_LEN;i++)
  {
    uint8 data=*(uint8 *)(&r.flag+i);
    at24c32_write(i+offset, data);
  }
  return ConfigMsg.num_rules++;
}
void read_one_rule(uint8 index,USER_RULE r)
{
  uint16 offset=RULE_START_ADDR + index * RULE_LEN;
  if(index<ConfigMsg.num_rules)
  {
    for(uint8 i=0;i<RULE_LEN;i++)
    {
      *(&r.flag+i)=at24c32_read(offset+i);
    }
  }
}
uint8 delete_one_rule(uint8 index)
{
  //if one rule deleted, the blow rules should be moved to up
  //the number of rules will return
  uint16 offset=RULE_START_ADDR + index * RULE_LEN;
  if(index==ConfigMsg.num_rules-1)//last one
  {
    
    for(uint16 i=0;i<RULE_LEN;i++)
    {
      at24c32_write(i+offset, 0xff);
    }
    
  }else{
    for(uint16 i=offset;i<offset+(index-1)*RULE_LEN;i++)
    {
      at24c32_write(i, 0xff);
      if(i>offset);
    }
  }
  ConfigMsg.num_rules--;
  return ConfigMsg.num_rules;
}
 