#include "base64.h"
#include "socket.h"
#include "config.h"
#include "w5500.h"

#include "weibo.h"

#include <stdio.h>
#include <string.h>

unsigned char post_wb_flag = 0;
unsigned char wb_sent = 0;
char weibo[141] = {0,};


WB_STATE wb_state=HTTPS_CONNECTED;

void do_weibo(void)
{
  if(post_wb_flag==0)
  {
    return;
  }
  //unsigned char WB_SIP[4] = {123,125,106,196};
  unsigned char state = 0;
  static unsigned int anyport = 2000;
  unsigned int len = 0;
  
  state = getSn_SR(SOCK_WB);
  switch(state)
  {
  case SOCK_INIT:
    connect(SOCK_WB, WB_SIP, HTTPS_PORT);
    break;
  case SOCK_ESTABLISHED:
    if(getSn_IR(SOCK_WB) & Sn_IR_CON)
    {
      setSn_IR(SOCK_WB, Sn_IR_CON);
      wb_state = HTTPS_CONNECTED;
      printf("connected\r\n");
    }
    //Oauth1
    switch (wb_state)
    {
    case HTTPS_CONNECTED:
      
      sprintf((char*)BUFPUB,"POST %s HTTP/1.1\r\nHost: %s\r\nAuthorization: Basic %s\r\nContent-Type: application/x-www-form-urlencoded\r\nContent-Length: %d\r\n\r\nsource=4277367807&status=%s", (char*)HTTPPATH,(char*)IPADDR,(char*)USERNAMEPASS, 24+strlen(weibo),(char*)weibo);
      //sprintf((char*)BUFPUB, "POST /oauth2/authorize\r\nUser-Agent: Mozilla/5.0 (Windows NT 6.1; rv:11.0) Gecko/20100101 Firefox/11.0\r\nHost: api.weibo.com\r\nReferer: https://api.weibo.com/oauth2/authorize?Client_id=%s&redirect_uri=%s&from=sina&response_type=code\r\nContent-Type: application/x-www-form-urlencoded\r\nContent-Length: %d\r\n\r\nclient_id=%s&redirect_uri=%s&userId=%s&passwd=%s&isLoginSina=0&action=submit&response_type=code",(char*)APP_KEY,(char*)CALLBACK_URL,162,(char*)APP_KEY,(char*)CALLBACK_URL,(char*)USERID,(char*)PASSWD);
      len=send(SOCK_WB,(unsigned char*)BUFPUB,strlen((char*)BUFPUB),0);
     
      wb_state = CODE_REQUESTED;
      break;
    case CODE_REQUESTED:
      break;
    case CODE_RECEIVED:
      break;
    case TOKEN_REQUESTED:
      break;
    case TOKEN_RECEIVED:
      break;
    case WB_POSTED:
      break;
    }
    
    /*
    if(wb_sent==0)
    {
      //post weibo
      //4277367807: chenguo.net
      //2702428363: iphone weibo helper
      sprintf((char*)BUFPUB,"POST %s HTTP/1.1\r\nHost: %s\r\nAuthorization: Basic %s\r\nContent-Type: application/x-www-form-urlencoded\r\nContent-Length: %d\r\n\r\nsource=4277367807&status=%s", (char*)HTTPPATH,(char*)IPADDR,(char*)USERNAMEPASS, 24+strlen(weibo),(char*)weibo);
      //"POST /statuses/update.xml HTTP/1.1\r\nHost: 128.121.146.100\r\nAuthorization: Basic bXlwbGFudDpndW9jaGVu\r\nContent-Length: 20\r\n\nstatus=567twitter t!" 
      len=send(SOCK_WB,(unsigned char*)BUFPUB,strlen((char*)BUFPUB),0);
      wb_sent = 1;
    }
    */
    if ((len = getSn_RX_RSR(SOCK_WB)) > 0)		
    {
       len=recv(SOCK_WB, BUFPUB, len);
       printf("weibo response: %s\r\n", (char*)BUFPUB);
       post_wb_flag = 0;
       disconnect(SOCK_WB);
    }
    break;
  case SOCK_CLOSE_WAIT:
    disconnect(SOCK_WB);
    break;
  case SOCK_CLOSED:
    socket(SOCK_WB, Sn_MR_TCP, anyport++, 0x00);
    break;
    
  }
}
void post_weibo(char* wb)
{
  unsigned int len = strlen(wb);
  if((len>0) && (len<140))
  {
    memcpy(weibo,wb,len);
    weibo[len] = 0;
    post_wb_flag = 1;
  }
}