#include "w5500/config.h"
#include "w5500/socket.h"
#include "w5500/util.h"
#include "w5500/w5500.h"
#include "w5500/device.h"
#include "w5500/SPI2.h"


#include <stdio.h> 
#include <string.h>
extern uint8 Enther_Flag;
CONFIG_MSG  ConfigMsg, RecvMsg;
uint8 pc_ip[4]={192,168,1,109};/*÷IPַ*/
uint16 pc_port = 5000;
uint8 buffer[128];/*һ2KBĻ*/


uint8 txsize[MAX_SOCK_NUM] = {2,2,2,2,2,2,2,2};
uint8 rxsize[MAX_SOCK_NUM] = {2,2,2,2,2,2,2,2};


//public buffer for DHCP, DNS, HTTP
uint8 pub_buf[1460];

void Reset_W5500(void)
{
  WIZ_RST(LOW);
  Delay_us(2);  
  WIZ_RST(HIGH);
  Delay_ms(1600);
}

void set_network(void)
{
  uint8 ip[4];
  setSHAR(ConfigMsg.mac);/*Macַ*/
  setSUBR(ConfigMsg.sub);/**/
  setGAR(ConfigMsg.gw);/*Ĭ*/
  setSIPR(ConfigMsg.lip);/*Ipַ*/

  //Init. TX & RX Memory size of w5500
  sysinit(txsize, rxsize); /*ʼ8socket*/
  
  setRTR(2000);/*ʱֵ*/
  setRCR(3);/*·ʹ*/
  

  getSIPR (ip);

  printf("IP : %d.%d.%d.%d\r\n", ip[0],ip[1],ip[2],ip[3]);

  getSUBR(ip);

  printf("SN : %d.%d.%d.%d\r\n", ip[0],ip[1],ip[2],ip[3]);

  getGAR(ip);

  printf("GW : %d.%d.%d.%d\r\n", ip[0],ip[1],ip[2],ip[3]);
 
}

void set_default(void)
{  
  uint8 mac[6]={0x00,0x08,0xdc,0x11,0x11,0x12};
  uint8 lip[4]={192,168,1,112};
  uint8 sub[4]={255,255,255,0};
  uint8 gw[4]={192,168,1,1};
  uint8 dns[4]={8,8,8,8};
  memcpy(ConfigMsg.lip, lip, 4);
  memcpy(ConfigMsg.sub, sub, 4);
  memcpy(ConfigMsg.gw,  gw, 4);
  memcpy(ConfigMsg.mac, mac,6);
  memcpy(ConfigMsg.dns,dns,4);

  ConfigMsg.dhcp=0;
  ConfigMsg.debug=1;
  ConfigMsg.fw_len=0;
  
  ConfigMsg.state=0;
  ConfigMsg.sw_ver[0]=FW_VER_HIGH;
  ConfigMsg.sw_ver[1]=FW_VER_LOW;
}

void do_tcpclient(uint8 s)
{
  uint16 anyport=3000;/*һ˿ڲʼ*/
  uint16 len;
  switch(getSn_SR(s))/*ȡsocket0״̬*/
    {
       case SOCK_INIT:/*socketʼ*/
         connect(s, pc_ip ,pc_port);/*TCPģʽ*/
         break;
       case SOCK_ESTABLISHED:/*socketӽ*/
         Enther_Flag=1;
         break;
       case SOCK_CLOSE_WAIT:/*socketȴر״̬*/
         break;
       case SOCK_CLOSED:/*socketر*/
         Enther_Flag=0;
         socket(s,Sn_MR_TCP,anyport,Sn_MR_ND);/*socket0һ˿*/
         break;
     }
}

